//Copyright (c) 2006-2007 Microsoft Corporation.  All rights reserved
using System;

namespace InvocationFramework.Adapters.Inproc.Attributes
{
    /// <summary>
    /// Atributo utilizado para marcar una clase como servicio
    /// </summary>
    [AttributeUsage( AttributeTargets.Class | AttributeTargets.Interface, Inherited = true, AllowMultiple = false )]
    public sealed class ServiceAttribute : Attribute
    {
        #region Constructors

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="name">Nombre del servicio</param>
        public ServiceAttribute( string name )
        {
            _name = name;
        }

        #endregion

        #region Properties

        /// <summary>
        /// Variable privada para el manejo de la propiedad
        /// </summary>
        private readonly string _name;

        /// <summary>
        /// Nombre del servicio
        /// </summary>
        public string Name
        {
            get
            {
                return _name;
            }
        }
        
        /// <summary>
        /// Variable privada para el manejo de la propiedad
        /// </summary>
        private string _description;

        /// <summary>
        /// Descripcion del servicio
        /// </summary>
        public string Description
        {
            get
            {
                return _description;
            }
            set
            {
                _description = value;
            }
        }

        #endregion
    }
}