//Copyright (c) 2006-2007 Microsoft Corporation.  All rights reserved
using System;

namespace InvocationFramework.Adapters.Inproc.Attributes
{
    /// <summary>
    /// Atributo utilizado para marcar un assembly que contiene servicios
    /// </summary>
    /// <author>Rodolfo Finochietti 03/11/2005 14.18</author>
    [AttributeUsage( AttributeTargets.Assembly, AllowMultiple = false )]
    public sealed class ServiceRepositoryAttribute : Attribute
    {
        #region Constructors

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="description">Descripcion del repositorio</param>
        public ServiceRepositoryAttribute( string description )
        {
            _description = description;
        }

        #endregion

        #region Properties

        /// <summary>
        /// Variable privada para el manejo de la propiedad
        /// </summary>
        private readonly string _description;

        /// <summary>
        /// Descripcion del repositorio
        /// </summary>
        public string Description
        {
            get
            {
                return _description;
            }
        }

        #endregion
    }
}
