//Copyright (c) 2006-2007 Microsoft Corporation.  All rights reserved
using System;

namespace InvocationFramework.Adapters.Inproc.Transactions
{
    /// <summary>
    /// Especifica el tipo de transaccion solicitado por un servicio
    /// </summary>
    /// <remarks>
    /// Una descripcion completa de cada opcion en <see cref="System.Transactions.TransactionScopeOption"/>
    /// </remarks>
    /// <author>Rodolfo Finochietti 30/12/2005 09:59</author>
    [Serializable]
    public enum TransactionScope
    {
        /// <summary>
        /// Disabled
        /// </summary>
        Disabled = -1,
        /// <summary>
        /// <seealso cref="System.Transactions.TransactionScopeOption.Suppress"/>
        /// </summary>
        Suppress = System.Transactions.TransactionScopeOption.Suppress,
        /// <summary>
        /// <seealso cref="System.Transactions.TransactionScopeOption.Required"/>
        /// </summary>
        Required = System.Transactions.TransactionScopeOption.Required,
        /// <summary>
        /// <seealso cref="System.Transactions.TransactionScopeOption.RequiresNew"/>
        /// </summary>
        RequiresNew = System.Transactions.TransactionScopeOption.RequiresNew
    }
}