//Copyright (c) 2006-2007 Microsoft Corporation.  All rights reserved
using System;

using InvocationFramework.Common;

namespace InvocationFramework.Adapters.Pipeline
{
    /// <summary>
    /// Estado de ejecucion del pipeline
    /// </summary>
    public class PipelineState
    {
        #region Constructors

        /// <summary>
        /// Constructor por defecto
        /// </summary>
        public PipelineState ( ) { }

        #endregion

        #region Properties

        /// <summary>
        /// Variable privada para el manejo de la propiedad
        /// </summary>
        private InvocationInformation _executionInformation;

        /// <summary>
        /// Informacion de la invocacion de un servicio
        /// </summary>
        public InvocationInformation ExecutionInformation
        {
            get
            {
                return _executionInformation;
            }
            set
            {
                _executionInformation = value;
            }
        }

        /// <summary>
        /// Variable privada para el manejo de la propiedad
        /// </summary>
        private PipelineType _pipeline;

        /// <summary>
        /// Indica el tipo de pipeline
        /// </summary>
        public PipelineType Pipeline
        {
            get
            {
                return _pipeline;
            }
            set
            {
                _pipeline = value;
            }
        }

	    #endregion    
    }
}