//Copyright (c) 2006-2007 Microsoft Corporation.  All rights reserved
using System;
using System.Runtime.Serialization;

namespace InvocationFramework.Common.Exceptions
{
    /// <summary>
    /// Excepcion que se produce al invocar un servicio
    /// </summary>
    /// <author>Rodolfo Finochietti 02/11/2005 16:00</author>
    [Serializable]
    public class InvocationFrameworkInvocationException : InvocationFrameworkException
    {
        #region Constructors
		
        /// <summary>
        /// Constructor por defecto
        /// </summary>
        public InvocationFrameworkInvocationException( ) : base( ) { }

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="message">Mensaje de la excepcion</param>
        public InvocationFrameworkInvocationException( string message ) : base( message ) { }

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="message">Mensaje de la excepcion</param>
        /// <param name="innerException">Excepcion contenida dentro de esta</param>
        public InvocationFrameworkInvocationException( string message, Exception innerException ) : base( message, innerException ) { }

        /// <summary>
        /// Constructror
        /// </summary>
        /// <param name="info"></param>
        /// <param name="context"></param>
        protected InvocationFrameworkInvocationException( SerializationInfo info, StreamingContext context ) : base( info, context ) { }

	    #endregion
    }
}