//Copyright (c) 2006-2007 Microsoft Corporation.  All rights reserved
using System;

namespace InvocationFramework.Common.Interfaces
{
    /// <summary>
    /// Interfaz para implementar estrategias de generadores de proxies
    /// </summary>
    /// <author>Rodolfo Finochietti 03/02/2006 23.25</author>
    public interface IProxyGenerator
    {
        /// <summary>
        /// Construye un proxy del tipo especificado en el parametro
        /// </summary>
        /// <typeparam name="T">Tipo del proxy a generar</typeparam>
        /// <param name="serviceName">Nombre del servicio al que se va a invocar utilizando el proxy generado</param>
        /// <returns>Un proxy del tipo especificado</returns>
        [System.Diagnostics.CodeAnalysis.SuppressMessage( "Microsoft.Design", "CA1004:GenericMethodsShouldProvideTypeParameter" )]
        T BuildProxy<T>( string serviceName ) where T : class;
    }
}