//Copyright (c) 2006-2007 Microsoft Corporation.  All rights reserved
using System;

using Microsoft.VisualStudio.TestTools.UnitTesting;

using InvocationFramework.Core.ProxyFactory;

using MockFilterTests.Contracts;

namespace MockFilterTests.UnitTests
{
    [TestClass]
    public class MockInvocations
    {
        #region Private Vars

        private ITestService _service;

        #endregion

        #region Constructors

        public MockInvocations( ) { }

        #endregion

        #region Support Methods

        [TestInitialize( )]
        public void Initialize( )
        {
            if ( _service == null )
            {
                ServiceProxyBuilder<ITestService> factory = new ServiceProxyBuilder<ITestService>( "TestService" );
                _service = factory.BuildProxy( );
            }
        }

        #endregion

        #region Test Methods

        [TestMethod]
        [Owner( "Rodolfo Finochietti" )]
        [DeploymentItem( "Cache.xml" )]
        public void InvokeMockOperation( )
        {
            Assert.AreEqual( "UnitTest", _service.GetSameString( "UnitTest" ) );
        }

        #endregion
   }
}