//Copyright (c) 2006-2007 Microsoft Corporation.  All rights reserved
using System;
using System.Xml;

using InvocationFramework.Adapters.Pipeline;

namespace PipelineAdapterTests.Common.Filters
{
    public class FirstFilter : IFilter
    {
        #region IFilter Members

        public void Init( XmlNode configuration ) { }

        public FilterResult Process( PipelineState state )
        {
            if ( state.Pipeline == PipelineType.Input && 
                 state.ExecutionInformation.ServiceName == "TestService" && 
                 state.ExecutionInformation.OperationName == "InputPipeline" )
            {
                state.ExecutionInformation.Parameters[ 0 ] = "PipelineType.Input";
                
                return FilterResult.Continue;
            }
            else if ( state.Pipeline == PipelineType.Output &&
                      state.ExecutionInformation.ServiceName == "TestService" && 
                      state.ExecutionInformation.OperationName == "OutputPipeline" )
            {
                state.ExecutionInformation.Result = "PipelineType.Output";
                
                return FilterResult.Continue;
            }
            else if ( state.ExecutionInformation.ServiceName == "TestService" &&
                 state.ExecutionInformation.OperationName == "StopFiltersChainInput" )
            {
                state.ExecutionInformation.Parameters[ 0 ] = "FirstFilterInput";

                return FilterResult.Stop;
            }
            else if ( state.ExecutionInformation.ServiceName == "TestService" &&
                      state.ExecutionInformation.OperationName == "StopFiltersChainOutput" )
            {
                state.ExecutionInformation.Result = "FirstFilterOutput";

                return FilterResult.Stop;
            }
            else if ( state.Pipeline == PipelineType.Input && 
                      state.ExecutionInformation.ServiceName == "TestService" &&
                      state.ExecutionInformation.OperationName == "CachedOperation" )
            {
                state.ExecutionInformation.Result = "CachedResult";

                return FilterResult.Continue;
            }
            else
            {
                return FilterResult.Continue;
            }
        }

        #endregion
    }
}