//Copyright (c) 2006-2007 Microsoft Corporation.  All rights reserved
using System;
using System.Xml;

using InvocationFramework.Adapters.Pipeline;

namespace PipelineAdapterTests.Common.Filters
{
    public class SecondFilter : IFilter
    {
        #region IFilter Members

        public void Init( XmlNode configuration ) { }

        public FilterResult Process( PipelineState state )
        {
            if ( state.ExecutionInformation.ServiceName == "TestService" && 
                 state.ExecutionInformation.OperationName == "StopFiltersChainInput" )
            {
                state.ExecutionInformation.Parameters[ 0 ] = "SecondFilter";
            }
            else if ( state.ExecutionInformation.ServiceName == "TestService" && 
                      state.ExecutionInformation.OperationName == "StopFiltersChainOutput" )
            {
                state.ExecutionInformation.Result = "SecondFilter";
            }

            return FilterResult.Continue;
        }

        #endregion
    }
}