//Copyright (c) 2006-2007 Microsoft Corporation.  All rights reserved
using System;

using Microsoft.VisualStudio.TestTools.UnitTesting;

using InvocationFramework.Core.ProxyFactory;

using PipelineAdapterTests.Common.Contracts;

namespace PipelineAdapterTests.UnitTests
{
    [TestClass]
    public class PipelineInvocations
    {
        #region Private Vars

        private ITestService _service;

        #endregion

        #region Constructors

        public PipelineInvocations( ) { }

        #endregion

        #region Support Methods

        [TestInitialize( )]
        public void Initialize( )
        {
            if ( _service == null )
            {
                ServiceProxyBuilder<ITestService> factory = new ServiceProxyBuilder<ITestService>( "TestService" );
                _service = factory.BuildProxy( );
            }
        }

        #endregion

        #region Test Methods

        [TestMethod]
        [Owner( "Rodolfo Finochietti" )]
        public void TestInputFilter( )
        {
            Assert.AreEqual( "PipelineType.Input", _service.InputPipeline( "UnitTest" ) );
        }

        [TestMethod]
        [Owner( "Rodolfo Finochietti" )]
        public void TestOutputFilter( )
        {
            Assert.AreEqual( "PipelineType.Output", _service.OutputPipeline( ) );
        }

        [TestMethod]
        [Owner( "Rodolfo Finochietti" )]
        public void TestStopFiltersChain( )
        {
            Assert.AreEqual( "FirstFilterInput", _service.StopFiltersChainInput( "UnitTest" ) );
            Assert.AreEqual( "FirstFilterOutput", _service.StopFiltersChainOutput( ) );
        }

        [TestMethod]
        [Owner( "Rodolfo Finochietti" )]
        public void TestCacheFilter( )
        {
            Assert.AreEqual( "CachedResult", _service.CachedOperation( ) );
        }

        #endregion
    }
}