//Copyright (c) 2006-2007 Microsoft Corporation.  All rights reserved
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using Microsoft.SqlServer.Server;

namespace RemotingAdapterTests.Contracts
{
    [Serializable( )]
    [XmlRoot( ElementName = "GetSalesOrderResult", Namespace = "RemotingAdapterTests.Objects" )]
    public class SalesOrderHeader
    {
        [XmlElement( )]
        public int SalesOrderID;

        [XmlElement( Type = typeof( Customer ) )]
        public Customer Customer;

        [XmlElement( )]
        public DateTime OrderDate;

        [XmlElement( )]
        public DateTime DueDate;

        [XmlElement( )]
        public DateTime ShipDate;

        [XmlElement( )]
        public byte Status;

        [XmlElement( )]
        public string PurchaseOrderNumber;

        [XmlElement( )]
        public decimal SubTotal;

        [XmlElement( )]
        public decimal TaxAmount;

        [XmlElement( )]
        public decimal Freight;

        [XmlElement( )]
        public decimal TotalDue;

        [XmlArray( ElementName = "SalesOrderDetails" )]
        public List<SalesOrderDetail> SalesOrderDetails;
    }
}