//Copyright (c) 2006-2007 Microsoft Corporation.  All rights reserved
using System;
using System.Collections.Generic;

using RemotingAdapterTests.Contracts;

namespace RemotingAdapterTests.Objects
{
    public class SalesService : MarshalByRefObject, ISalesServiceContract
    {
        public SalesService( ) { }

        public SalesOrderHeader GetSalesOrderById( int id )
        {
            if ( id == 56343 )
            {
                SalesOrderHeader order = new SalesOrderHeader( );

                order.Customer = new Customer( );
                order.Customer.AccountNumber = "011-0888882/2";
                order.Customer.CustomerID = 2567;
                order.Customer.CustomerType = "PyME";
                order.Customer.StoreName = "Adventure Works";

                order.PurchaseOrderNumber = "AB3982938";
                order.Freight = 156.45M;
                order.SalesOrderID = 56343;

                order.SalesOrderDetails = new List<SalesOrderDetail>( );

                SalesOrderDetail detail = new SalesOrderDetail( );
                detail.LineTotal = 100M;
                detail.OrderQty = 5;
                detail.UnitPrice = 20M;
                detail.UnitPriceDiscount = 0;
                detail.ProductName = "Sample Product";
                detail.SalesOrderDetailID = 1234;
                order.SalesOrderDetails.Add( detail );


                detail = new SalesOrderDetail( );
                detail.LineTotal = 1000M;
                detail.OrderQty = 4;
                detail.UnitPrice = 250M;
                detail.UnitPriceDiscount = 0;
                detail.ProductName = "Sample Product 2";
                detail.SalesOrderDetailID = 1235;

                return order;
            }
            else
            {
                if ( id == 666 )
                    throw new DiabolicException( );
                else
                    return null;
            }

        }

        public SalesOrderDataSet GetSalesOrderDataSet( int id )
        {
            SalesOrderDataSet ds = new SalesOrderDataSet( );

            SalesOrderDataSet.CustomerRow customer = ds.Customer.NewCustomerRow( );
            customer.AccountNumber = "011-0888882/2";
            customer.CustomerID = 2567;
            customer.CustomerType = "PyME";
            customer.StoreName = "Adventure Works";
            ds.Customer.AddCustomerRow( customer );

            SalesOrderDataSet.SalesOrderDetailRow detail = ds.SalesOrderDetail.NewSalesOrderDetailRow( );
            detail.LineTotal = 100M;
            detail.OrderQty = 5;
            detail.UnitPrice = 20M;
            detail.UnitPriceDiscount = 0;
            detail.ProductName = "Sample Product";
            detail.SalesOrderDetailID = 1234;
            ds.SalesOrderDetail.AddSalesOrderDetailRow( detail );

            SalesOrderDataSet.SalesOrderHeaderRow order = ds.SalesOrderHeader.NewSalesOrderHeaderRow( );
            order.PurchaseOrderNumber = "AB3982938";
            order.Freight = 156.45M;
            order.SalesOrderID = 56343;
            order.DueDate = System.DateTime.Now;
            order.OrderDate = System.DateTime.Now;
            order.ShipDate = System.DateTime.Now;
            order.Status = 1;
            order.SubTotal = 135M;
            order.TaxAmount = 14.86M;
            order.TotalDue = 83.32M;

            ds.SalesOrderHeader.AddSalesOrderHeaderRow( order );

            return ds;
        }
    }
}