//Copyright (c) 2006-2007 Microsoft Corporation.  All rights reserved
using System;
using System.EnterpriseServices;
using System.Data;

using ServicedComponentAdapterTest.Contracts;

namespace ServicedComponentAdapterTest.Services
{
    [Transaction( TransactionOption.RequiresNew )]
    public class TestService : ServicedComponent, ITestContract
    {
        [AutoComplete]
        public string GetSameString( string param )
        {
            return param;
        }

        [AutoComplete]
        public DataSet GetDataSet( )
        {
            DataSet ds = new DataSet( "UnitTestDataSet" );

            DataTable table = new DataTable( "UnitTestTable" );

            table.Columns.Add( "Id", typeof( int ) );
            table.Columns.Add( "Description", typeof( string ) );

            table.Rows.Add( 1, "Row 1" );
            table.Rows.Add( 2, "Row 2" );
            table.Rows.Add( 3, "Row 3" );
            table.Rows.Add( 4, "Row 4" );
            table.Rows.Add( 5, "Row 5" );
            table.Rows.Add( 6, "Row 6" );
            table.Rows.Add( 7, "Row 7" );
            table.Rows.Add( 8, "Row 8" );

            ds.Tables.Add( table );

            return ds;
        }

        [AutoComplete]
        public void ExceptionOperation( )
        {
            throw new ApplicationException( );
        }
    }
}