//Copyright (c) 2006-2007 Microsoft Corporation.  All rights reserved
using System;
using System.Collections.Generic;
using System.Data;
using System.Web;
using System.Collections;
using System.Web.Services;
using System.Web.Services.Protocols;

using WebServiceAdapterTests.Common.Contracts;
using WebServiceAdapterTests.Common.DataTransferObjects;

[WebService( Namespace = "http://tempuri.org/" )]
[WebServiceBinding( ConformsTo = WsiProfiles.BasicProfile1_1 )]
public class DTOService : System.Web.Services.WebService, IDTOService
{
    public DTOService( ) { }

    [WebMethod]
    public BasicDto GetBasicDto( BasicDto dto )
    {
        return dto;
    }

    [WebMethod]
    public CollectionDto GetCollectionDto( CollectionDto dto )
    {
        return dto;
    }

    [WebMethod]
    public DataDto GetDataDto( DataDto dto )
    {
        return dto;
    }

    [WebMethod]
    public ComplexDto GetComplexDto( )
    {
        ComplexDto dto = new ComplexDto( );

        dto.Basic = new BasicDto( );
        dto.Basic.StringProperty = "One";
        dto.Basic.Int32Property = 1;
        dto.Basic.StringArrayProperty = new string[] { "1", "2", "3" };

        dto.Collection = new CollectionDto( );
        dto.Collection.ArrayListProperty = new ArrayList( );
        dto.Collection.ArrayListProperty.Add( "1" );
        dto.Collection.ArrayListProperty.Add( "2" );
        dto.Collection.GenericListProperty = new List<int>( );
        dto.Collection.GenericListProperty.Add( 1 );
        dto.Collection.GenericListProperty.Add( 2 );

        dto.Data = new DataDto( );
        dto.Data.DataSetProperty = new DataSet( "UnitTestDataSet" );
        dto.Data.DataSetProperty.Tables.Add( BuildTable( ) );

        return dto;
    }

    public DataTable BuildTable( )
    {
        DataTable table = new DataTable( "UnitTestTable" );

        table.Columns.Add( "Id", typeof( int ) );
        table.Columns.Add( "Description", typeof( string ) );

        table.Rows.Add( 1, "Row 1" );
        table.Rows.Add( 2, "Row 2" );
        table.Rows.Add( 3, "Row 3" );
        table.Rows.Add( 4, "Row 4" );
        table.Rows.Add( 5, "Row 5" );

        return table;
    }
}