//Copyright (c) 2006-2007 Microsoft Corporation.  All rights reserved
using System;
using System.Data;
using System.Web;
using System.Collections;
using System.Web.Services;
using System.Web.Services.Protocols;

using WebServiceAdapterTests.Common.Contracts;
using WebServiceAdapterTests.Common.DataTransferObjects;
using WebServiceAdapterTests.Common.DataTransferObjects.TypedDSTableAdapters;

[WebService( Namespace = "http://tempuri.org/" )]
[WebServiceBinding( ConformsTo = WsiProfiles.BasicProfile1_1 )]
public class DataService : System.Web.Services.WebService, IDataService
{
    public DataService( ) { }

    [WebMethod]
    public DataSet GetDataSet( )
    {
        DataSet ds = new DataSet( "UnitTestDataSet" );

        DataTable table = new DataTable( "UnitTestTable" );

        table.Columns.Add( "Id", typeof( int ) );
        table.Columns.Add( "Description", typeof( string ) );

        table.Rows.Add( 1, "Row 1" );
        table.Rows.Add( 2, "Row 2" );
        table.Rows.Add( 3, "Row 3" );
        table.Rows.Add( 4, "Row 4" );
        table.Rows.Add( 5, "Row 5" );
        table.Rows.Add( 6, "Row 6" );
        table.Rows.Add( 7, "Row 7" );
        table.Rows.Add( 8, "Row 8" );

        ds.Tables.Add( table );

        return ds;
    }

    [WebMethod]
    public TypedDS.CurrencyDataTable GetTypedDS( TypedDS.CurrencyDataTable table )
    {
        TypedDS.CurrencyRow row1 = table.NewCurrencyRow( );
        row1.CurrencyCode = "1";
        row1.Name = "Row 1";
        row1.ModifiedDate = DateTime.Now;
        table.Rows.Add( row1 );

        TypedDS.CurrencyRow row2 = table.NewCurrencyRow( );
        row2.CurrencyCode = "2";
        row2.Name = "Row 2";
        row2.ModifiedDate = DateTime.Now;
        table.Rows.Add( row2 );

        table.AcceptChanges( );

        return table;
    }
}